Ruby - Bug #18837

Not possible to evaluate expression with numbered parameters in it
06/17/2022 12:48 PM - hurricup (Alexandr Evstigneev)

Status: Rejected
Priority: Normal
Assignee:

Target version:

ruby -v: Backport: 2.7: UNKNOWN, 3.0: UNKNOWN, 3.1:
UNKNOWN

Description
| presume it's not really a bug, but design flaw, but this is really frustrating. Use case is - debugger.

Here is script with expected behavior:

def dumper (bnd)
puts bnd.local_variable_get 'i'
puts bnd.eval 'i * 10'

end

[1,2].each { |i] dumper (binding) }
And this one attempts to do the same with numbered params:

def dumper (bnd)
puts bnd.local_variable_get ('_1")
puts bnd.eval '_1 * 10

end

[1,2] .each do

some = _1 # without this line even local_variable_get won't work, still it may be in any place
of block

dumper (binding)
end

But eval wont ever work and this necessity for using _1 so binding could see it may be confusing as well.

Related issues:

Related to Ruby - Feature #15915: "@1" cannot be achieved in meta-programming Closed
Related to Ruby - Feature #19137: Numbered parameters are not made available ... Open
Has duplicate Ruby - Bug #20308: "it' and numbered parameters do not work in ... Closed
History

#1 - 06/17/2022 01:46 PM - mame (Yusuke Endoh)

- Related to Feature #15915: ‘@1 cannot be achieved in meta-programming added
#2 - 07/20/2022 01:58 AM - mame (Yusuke Endoh)
| talked a bit with some of the committers.

@ko1 (Koichi Sasada) said that it is difficult to retrieve _1 afterwards due to the current implementation limitation, since the actual arguments may be
dropped by optimization when a block that does not accept formal arguments is called.

Also, @znz (Kazuhiro NISHIYAMA) pointed out that the meta-programming API to read out only _1 is somewhat unreasonable, since the meaning of
_1 depends on the presence of _2.

{ 1 => "A" }.each do
p _1 #=> [1, "A"]

end

{ 1 => "A" }.each do
p _1 #=>1
end

#3 - 07/21/2022 12:28 PM - mame (Yusuke Endoh)
- Status changed from Open to Rejected

We discussed this issue at the dev meeting. @matz (Yukihiro Matsumoto) agreed that it is difficult to support this for the reasons | said in #note-2.

#4 - 11/24/2022 05:06 PM - alanwu (Alan Wu)

- Related to Feature #19137: Numbered parameters are not made available to IRB. added

#5 - 02/28/2024 11:12 AM - nobu (Nobuyoshi Nakada)

- Has duplicate Bug #20308: "it" and numbered parameters do not work in “eval” added
